/**
 * @file 		SimpleModbusRtu.h
 * @version     1.0
 * @date        2016.10.5
 * @Copyright   comfiletechnology
 * @make by		hwang young
 * @ www.comfile.co.kr
 *
 */

#include <inttypes.h>
#include "Arduino.h"
#include "Print.h"
#include <MsTimer2_mega2560.h>

void SysTickHandler(void);
void comPut(u8 comch, u8 cha);
void push_ringbuffer(u8 comch, u8 comdt);
void startSimpleModbus(u8 comch, u8 modslaveadr, u16 * modbusBufferRegister, u8 * modbusBufferCoil);

static HardwareSerial *port; //!< Pointer to Serial class object
unsigned char ch_serial=0;

/*******************************************************************************

  Function Name  : comPut
  1Ʈ 
*******************************************************************************/


void StartModbus()
{
	while (port->available()>0)
	{ push_ringbuffer( 0,port->read() ); }	
	
}

void SetModbus(u8 Serial_ch, u32 Baud, u8 Addr ,uint16_t *Register, uint8_t *Coil )
{
	switch( Serial_ch ) {
	/*
	#if defined(UBRR1H)
		case 1:
		port = &Serial1;
    	break;
	#endif

	#if defined(UBRR2H)
  		case 2:
    	port = &Serial2;
    	break;
	#endif

	#if defined(UBRR3H)
  		case 3:
    	port = &Serial3;
    	break;
	#endif
	*/
  	case 1:
    port = &Serial1;
    break;
    
    case 2:
    port = &Serial2;
    break;
  	
  	case 0:
  	//default:
    port = &Serial;
    break;
  }
  ch_serial = Serial_ch;
  startSimpleModbus(0, Addr, Register, Coil);
  port->begin(Baud);
  port->flush();

  MsTimer2::set(1, SysTickHandler); 
  MsTimer2::start();
}

//u16 __commodeMaskFlag[4];
void comFlush(u8 comch);

void comPut(u8 comch, u8 cha)
{

/*
    switch( comch ) {
	#if defined(UBRR1H)
    	case 1:
      	UCSR1A=UCSR1A |(1 << TXC1);
      	port->write(cha);
      	while (!(UCSR1A & (1 << TXC1)));
      	break;
	#endif

	#if defined(UBRR2H)
    	case 2:
      	UCSR2A=UCSR2A |(1 << TXC2);
      	port->write(cha);
      	while (!(UCSR2A & (1 << TXC2)));
      	break;
	#endif

	#if defined(UBRR3H)
    	case 3:
      	UCSR3A=UCSR3A |(1 << TXC3);
      	port->write(cha);
      	while (!(UCSR3A & (1 << TXC3)));
      	break;
	#endif
   */ 	
    switch( ch_serial ) {
    	case 0:
    	//default:
    	 UCSR0A=UCSR0A |(1 << TXC0);
      	port->write(cha);
      	while (!(UCSR0A & (1 << TXC0)));
      	break;
      	
      	      	
		case 1:
    	//default:
    	UCSR1A=UCSR1A |(1 << TXC1);
      	port->write(cha);
        while (!(UCSR1A & (1 << TXC1)));
      	break;
      	
      	case 2:
    	//default:
    	UCSR2A=UCSR2A |(1 << TXC2);
      	port->write(cha);
        while (!(UCSR2A & (1 << TXC2)));
      	break;
      	
      	default:
    	UCSR0A=UCSR0A |(1 << TXC0);
      	port->write(cha);
      	while (!(UCSR0A & (1 << TXC0)));
      	break;
    }
	port->flush();
}


/*******************************************************************************

  Ring buffer Management

*******************************************************************************/

#define __ring_buffer_max 120//255
u8 __ring_buffer[4][120];    //255
u16 __save_pointer[4]={0,0,0,0};
u16 __action_pointer[4]={__ring_buffer_max, __ring_buffer_max, __ring_buffer_max, __ring_buffer_max};

u8 __modbusSwitch[4]={0,0,0,0};
u16 __modbusBlankCheck = 0;

//  RS232 RXͷƮ ó 

void modbusFrameSearch(u8 comch);

void push_ringbuffer(u8 comch, u8 comdt)
{
  //if (__commodeMaskFlag[comch]) comdt &= 0x7f; 

  if (__modbusSwitch[comch]) {
    if (__modbusBlankCheck > 500) {
        comFlush(comch); 
        }
    __modbusBlankCheck = 0;
    }

  if(__save_pointer[comch]!=__action_pointer[comch]){
    __ring_buffer[comch][__save_pointer[comch]]=comdt;
    __save_pointer[comch]++;
    if(__save_pointer[comch]>__ring_buffer_max) { 
      __save_pointer[comch]=0; 
      }
  }  
  if (__modbusSwitch[comch]) modbusFrameSearch(comch);
}

u8 read_ringbuffer(u8 comch)
{
  __action_pointer[comch]++;
  if(__action_pointer[comch] > __ring_buffer_max){ 
    __action_pointer[comch]=0; 
    }  
  return(__ring_buffer[comch][__action_pointer[comch]]);
}

/*******************************************************************************

  Function Name  : comFlush
   

*******************************************************************************/

void comFlush(u8 comch)
{ 
  __action_pointer[comch] = __ring_buffer_max;
  __save_pointer[comch] = 0;
}

/*******************************************************************************

  Function Name  : comLen
  ring buffer ִ   

*******************************************************************************/

u16 comLen(u8 comch)
{ 
  u16 i;  
  if (__save_pointer[comch]>(__action_pointer[comch]+1)) { 
    i=__save_pointer[comch]-__action_pointer[comch]-1;
    }
  else if (__save_pointer[comch]<(__action_pointer[comch]+1)) {
    i=__ring_buffer_max-__action_pointer[comch]+__save_pointer[comch]; 
    }
  else {
    i=0;
    }
  return(i);
}

/*******************************************************************************

  Function Name  : comGet
  1Ʈ б

*******************************************************************************/

short comGet(u8 comch)
{
  if (comLen(comch) == 0) return -1;
  return read_ringbuffer(comch);
}

/*******************************************************************************

  Function Name  : comGets
  nƮ б

*******************************************************************************/

short comGets(u8 comch, u8 * dest, u16 length)
{
  u16 i;
  if (comLen(comch) == 0) return 0;
  for (i=0; i<length; i++) {
    dest[i] = read_ringbuffer(comch);
    }
  return -1;
}

/*******************************************************************************

  Function Name  : comPuts
  nƮ 

*******************************************************************************/

void comPuts(u8 comch, u8 * dest, u16 length)
{
  u16 i;
  for (i=0; i<length; i++) {
    comPut(comch,dest[i]);
    }
}


/*******************************************************************************

  Simple   ó 
  
*******************************************************************************/

void mb_crc_compute(u8 rch);

u8 __modbusComCh=0;
u8 __modbusSlaveAdr=0;
u16 * __modbusWordBuffer;
u8 * __modbusBitBuffer;
u8 __modbusBroadMode = 0;
u8 __modbusFoundFrame = 0;
u16 __modbusIntervalCounter=0;;
u8 uchCRCHi, uchCRCLo;
u16 uINDEX;

u8 mb_get_byte_rtu()
{
  return read_ringbuffer(__modbusComCh);
}

u16 mb_get_word_rtu()
{
  u16 wi;
  wi = read_ringbuffer(__modbusComCh);
  wi <<= 8;
  wi += read_ringbuffer(__modbusComCh);
  return wi;
}

void mb_inc_pointer()
{
  (void)read_ringbuffer(__modbusComCh);
}

void mb_put_byte_rtu(u8 dt)
{
  comPut(__modbusComCh, dt);
  mb_crc_compute(dt);
}

const u8 mb_ncdtb[] = {1,2,4,8,16,32,64,128};

u8 mb_collectbits(u16 adr)
{
  u8 i,j,m=0;              
  for (i=0;i<8;i++) {       
    j = __modbusBitBuffer[adr>>3];
    if (j & mb_ncdtb[adr & 7]) m |= mb_ncdtb[i];
    adr++;
    }
  return m;
}

void mbcmd_read_bit_rtu(u8 cmd)
{
  u8 i,j,bln;
  u16 stadr,ln;
  stadr = mb_get_word_rtu();
  ln = mb_get_word_rtu();
  mb_inc_pointer();
  mb_inc_pointer(); 
  
  if (__modbusBroadMode) return;
  uchCRCHi = uchCRCLo = 0xff;   
  mb_put_byte_rtu(__modbusSlaveAdr);
  mb_put_byte_rtu(cmd);        
  bln = ln >> 3;
  if (ln & 7) bln++;          
  mb_put_byte_rtu(bln);       
  for (i=0; i<bln; i++) {
    j=mb_collectbits(stadr);
    mb_put_byte_rtu(j);
    stadr += 8;
    }
  i = uchCRCLo; 
  mb_put_byte_rtu(uchCRCHi); 
  mb_put_byte_rtu(i);
}

//
//  1 Bit  (FC 5)
//

void mbcmd_write_bit_single_rtu()
{
  u8 i;
  u16 stadr,realadr,val;
  stadr = mb_get_word_rtu(); 
  val = mb_get_word_rtu(); 
  mb_inc_pointer(); 
  mb_inc_pointer();
  
  realadr = stadr >> 3;
  if (val) __modbusBitBuffer[realadr] |= mb_ncdtb[stadr & 7];
  else __modbusBitBuffer[realadr] &= ~mb_ncdtb[stadr & 7];
  
  if (__modbusBroadMode) return;    
  uchCRCHi = uchCRCLo = 0xff;   
  mb_put_byte_rtu(__modbusSlaveAdr);
  mb_put_byte_rtu(5);           
  mb_put_byte_rtu(stadr >> 8);
  mb_put_byte_rtu(stadr);
  mb_put_byte_rtu(val >> 8);
  mb_put_byte_rtu(val);
  i = uchCRCLo;
  mb_put_byte_rtu(uchCRCHi); 
  mb_put_byte_rtu(i);
}

//
//  MODBUS RTU Word Read  (FC 3, 4)
//

void mbcmd_read_word_rtu(u8 cmd)
{
  u8 i;
  u16 stadr,ln,li,dt;
  stadr = mb_get_word_rtu(); 
  ln = mb_get_word_rtu(); 
  mb_inc_pointer();
  mb_inc_pointer();   
  //
  //  Send Start
  //
  if (__modbusBroadMode) return;   
  uchCRCHi = uchCRCLo = 0xff;   
  mb_put_byte_rtu(__modbusSlaveAdr);
  mb_put_byte_rtu(cmd);         
  i = ln << 1;
  mb_put_byte_rtu(i);           

  for (li=0; li<ln; li++) {
    dt = __modbusWordBuffer[stadr++];
    mb_put_byte_rtu(dt >> 8);
    mb_put_byte_rtu(dt); 
    }
  i = uchCRCLo;
  mb_put_byte_rtu(uchCRCHi); 
  mb_put_byte_rtu(i);
}

//
//    1常  (FC 6)
//

void mbcmd_write_word_single_rtu()
{
  u8 lsave,i;
  u16 stadr,realadr,val;
  stadr = mb_get_word_rtu(); 
  val = mb_get_word_rtu(); 
  mb_inc_pointer();
  mb_inc_pointer();   
  __modbusWordBuffer[stadr] = val;
    
  if (__modbusBroadMode) return;
  uchCRCHi = uchCRCLo = 0xff;   
  mb_put_byte_rtu(__modbusSlaveAdr);
  mb_put_byte_rtu(6);          
  mb_put_byte_rtu(stadr >> 8);
  mb_put_byte_rtu(stadr);
  mb_put_byte_rtu(val >> 8);
  mb_put_byte_rtu(val);
  i = uchCRCLo; 
  mb_put_byte_rtu(uchCRCHi);
  mb_put_byte_rtu(i);
}


//
//   Bit  RTU (FC 15)
//

void mb_writebits(u16 adr, u8 val, u8 ln)
{
  u8 i,m;
  if (ln > 7) m=8;
    else m=ln;   
  for (i=0;i<m;i++) { 
    if (val & mb_ncdtb[i]) 
      __modbusBitBuffer[adr >> 3] |= mb_ncdtb[adr & 7];
    else 
      __modbusBitBuffer[adr >> 3] &= ~mb_ncdtb[adr & 7];
    adr++;
    }
}

void mbcmd_write_bit_multiple_rtu()
{
  u8 i,j,cnt;
  u16 stadr,ln,lnsave,stadr_save;
  stadr_save = stadr = mb_get_word_rtu(); 
  lnsave = ln = mb_get_word_rtu(); 
  cnt = mb_get_byte_rtu(); 
  for (i=0; i<cnt; i++) {
    j = mb_get_byte_rtu(); 
    mb_writebits(stadr, j, ln);
    stadr += 8;
    ln -= 8;
    }
  mb_inc_pointer();
  mb_inc_pointer();     
  // ۽Ž
  if (__modbusBroadMode) return;    
  uchCRCHi = uchCRCLo = 0xff;   
  mb_put_byte_rtu(__modbusSlaveAdr);
  mb_put_byte_rtu(15);         
  mb_put_byte_rtu(stadr_save >> 8);
  mb_put_byte_rtu(stadr_save);
  mb_put_byte_rtu(lnsave >> 8);
  mb_put_byte_rtu(lnsave);
  i = uchCRCLo; 
  mb_put_byte_rtu(uchCRCHi); // CRC
  mb_put_byte_rtu(i);
}

//
//       RTU (FC 16)
//

void mbcmd_write_word_multiple_rtu()
{
  u8 j;
  u16 stadr,realadr,val,ln,i;
  realadr = stadr = mb_get_word_rtu(); 
  ln = mb_get_word_rtu(); 
  mb_inc_pointer(); 
  for (i=0;i<ln;i++) {
    val = mb_get_word_rtu(); 
    __modbusWordBuffer[realadr++] = val;      
    }
  mb_inc_pointer();
  mb_inc_pointer(); 
  
  if (__modbusBroadMode) return;    
  uchCRCHi = uchCRCLo = 0xff;   
  mb_put_byte_rtu(__modbusSlaveAdr);
  mb_put_byte_rtu(16);          
  mb_put_byte_rtu(stadr >> 8);
  mb_put_byte_rtu(stadr);
  mb_put_byte_rtu(ln >> 8);
  mb_put_byte_rtu(ln);
  j = uchCRCLo; 
  mb_put_byte_rtu(uchCRCHi);
  mb_put_byte_rtu(j);
}


/*******************************************************************************

  Function Name  : startModbus
   MAIN ó
  
*******************************************************************************/

const u8 auchCRCH[]  =  {
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81,
0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,0x40};

const u8 auchCRCL[] = {
0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06, 0x07, 0xC7, 0x05, 0xC5, 0xC4,
0x04, 0xCC, 0x0C, 0x0D, 0xCD, 0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A, 0x1E, 0xDE, 0xDF, 0x1F, 0xDD,
0x1D, 0x1C, 0xDC, 0x14, 0xD4, 0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3, 0xF2, 0x32, 0x36, 0xF6, 0xF7,
0x37, 0xF5, 0x35, 0x34, 0xF4, 0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29, 0xEB, 0x2B, 0x2A, 0xEA, 0xEE,
0x2E, 0x2F, 0xEF, 0x2D, 0xED, 0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60, 0x61, 0xA1, 0x63, 0xA3, 0xA2,
0x62, 0x66, 0xA6, 0xA7, 0x67, 0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68, 0x78, 0xB8, 0xB9, 0x79, 0xBB,
0x7B, 0x7A, 0xBA, 0xBE, 0x7E, 0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71, 0x70, 0xB0, 0x50, 0x90, 0x91,
0x51, 0x93, 0x53, 0x52, 0x92, 0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B, 0x99, 0x59, 0x58, 0x98, 0x88,
0x48, 0x49, 0x89, 0x4B, 0x8B, 0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42, 0x43, 0x83, 0x41, 0x81, 0x80,0x40};

void mb_crc_compute(u8 rch)
{
  uINDEX = uchCRCHi ^ rch;
  uchCRCHi = uchCRCLo ^ auchCRCH[uINDEX];
  uchCRCLo = auchCRCL[uINDEX];
}


u16 getCrc(u8 * targetArray, u16 datalength)
{
  u16 d;
  uchCRCHi = uchCRCLo = 0xff;   
  for (d=0; d<datalength; d++) {
    mb_crc_compute(targetArray[d]);
    }
  d = (uchCRCHi << 8) + uchCRCLo;
  return d;
}


void startSimpleModbus(u8 comch, u8 modslaveadr, u16 * modbusBufferRegister, u8 * modbusBufferCoil)
{
  __modbusComCh = comch;
  __modbusSlaveAdr = modslaveadr;
  __modbusSwitch[0] = 0;
  __modbusSwitch[1] = 0;
  __modbusSwitch[2] = 0;
  __modbusSwitch[3] = 0; 
  __modbusSwitch[comch] = 1;
  __modbusWordBuffer = modbusBufferRegister;
  __modbusBitBuffer = modbusBufferCoil;
}


void modbusFrameSearch(u8 comch)
{
  u8 uch, ucl, bh, bl;
  u16 mclen, i;
  u16 uix;
  u16 save_pointer;
  mclen = comLen(comch); 

  if (mclen < 8) return; 

  uch = ucl = 0xff;      
  save_pointer = __action_pointer[comch];
  for (i = 0; i< mclen-2; i++) {
    uix = uch ^ mb_get_byte_rtu();
    uch = ucl ^ auchCRCH[uix];
    ucl = auchCRCL[uix];
    }
  bh = mb_get_byte_rtu();
  bl = mb_get_byte_rtu();
  __action_pointer[comch] = save_pointer;

  if ((bh == uch) && (bl == ucl)) __modbusFoundFrame = 1;
    
}

void modbusMainProcessing()
{
  u8 fc,sladr;
  sladr = mb_get_byte_rtu(); 
  if (sladr == 0) {
    __modbusBroadMode = 1; 
    }
  else {
    if (sladr != __modbusSlaveAdr) { 
      comFlush(__modbusComCh);
      return;
      }
   }
 
  fc = mb_get_byte_rtu(); 
 
  switch (fc) {
  case 1:
  case 2:
    mbcmd_read_bit_rtu(fc);
    break;
  case 3:
  case 4:
    mbcmd_read_word_rtu(fc);
    break;
  case 5:
    mbcmd_write_bit_single_rtu();
    break;
  case 6:
    mbcmd_write_word_single_rtu();
    break;
  case 15:
    mbcmd_write_bit_multiple_rtu();
    break;
  case 16:
    mbcmd_write_word_multiple_rtu();
    break;
  default:
    comFlush(__modbusComCh); 
    return;
    }
}  

#define __modbusReturnInterval 5

/*******************************************************************************
* Function Name  : SysTickHandler (1mS ɸ.)
*******************************************************************************/

void SysTickHandler(void)
{
    
  if (__modbusFoundFrame) {
    __modbusIntervalCounter++;
    if (__modbusIntervalCounter > __modbusReturnInterval) {
      __modbusIntervalCounter = 0;
      __modbusFoundFrame = 0;
      modbusMainProcessing();
    }
   }
  if (__modbusBlankCheck < 0xffff) __modbusBlankCheck++;

}